

//Palmer 
//www.fxtradeblog.com
//ADXColorBar

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color2 C'57,128,22' //GREEN
#property indicator_color3 C'255,32,32' //RED 

extern int    ADXPeriod=14;

// buffer store
   double     valB0[];   
   double     valB1[];
   
 
    

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init()
{
   SetIndexBuffer(0,valB0);
   SetIndexBuffer(1,valB1);
   
  SetIndexStyle(0,DRAW_HISTOGRAM, EMPTY, 4, C'57,128,22'); //GREEN
  SetIndexStyle(1,DRAW_HISTOGRAM, EMPTY, 4, C'255,32,32'); //RED
   
   for (int i=0;i<indicator_buffers;i++) SetIndexLabel(i,NULL);   


   IndicatorShortName("ADXColorBar");
   return(1);
}

int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int start()
  {
  
  
  
   int    counted_bars=IndicatorCounted();
   
//ERROR CHECK
   if (counted_bars<0) return(-1);
//BAR RECOUNT
   if (counted_bars>0) counted_bars--;
   int    gap=Bars-counted_bars;
 
   double aa;
   double bb;
   double cc;
  
  
//Calculation for ADX
   while(gap>=0)
     {   
         aa=iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MAIN,gap);//MAIN ADX
         bb=iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,gap);//DM POS
         cc=iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,gap);// DM NEG 
    
               if (cc > bb)
               {drawblock(0,5,gap);}// Red
                   
               if (bb > cc)
               {drawblock(5,0,gap);}// Green
                     
         gap--;
     }
//----
   return(0);
  }
      
void drawblock(int a,int b,int gap)

{
         
    valB0[gap]=a;    
    valB1[gap]=b;
               
} 